' ISAMDEMO.BAS - Adreverwaltung zur Demonstration der ISAM-Fhigkeiten

DECLARE SUB AnzeigeDatensatz (Modus AS INTEGER)
DECLARE SUB DatenbankOeffnen ()
DECLARE SUB Datenliste ()
DECLARE SUB DatensatzEingabe (Vorgabe AS ANY, NeuerSatz AS ANY)
DECLARE SUB HauptMenue ()
DECLARE SUB SucheDatensatz (Titel AS STRING)

CONST Datenbank = "Adressen"              ' Datenbankname in der ISAM-Datei
CONST Datenfile = "ISAMDEMO.ISM"          ' Name der ISAM-Datei
CONST Ausfuehrlich = 1, Kurz = 2          ' Anzeigemodi fr AnzeigeDatensatz

TYPE Datentyp                             ' Datentyp fr ISAM-Zugriff
   Name AS STRING * 30
   Vorname AS STRING * 30
   Strasse AS STRING * 40
   PLZ AS STRING * 6
   Ort AS STRING * 30
   Telefon AS STRING * 30
END TYPE

DIM SHARED Zugriff AS Datentyp            ' Zugriffsvariable
DIM SHARED Leer AS Datentyp               ' Leere Adresse

Leer.Name = "": Leer.Vorname = ""         ' Ohne diese Befehle enthielte die
Leer.Strasse = "": Leer.PLZ = ""          ' "leere Adresse" lauter CHR$(0)-
Leer.Ort = "": Leer.Telefon = ""          ' Zeichen, und RTRIM wrde nicht
                                          ' funktionieren. Hierdurch wird die
                                          ' "leere Adresse" mit CHR$(32),
                                          ' also Leerzeichen gefllt.

DatenbankOeffnen                          ' Eingangsmeldung anzeigen & Daten-
                                          ' bank als Datei #1 ffnen

HauptMenue                                ' Hauptmen

PRINT "Sollen die nderungen, die"
PRINT "Sie gemacht haben, gespei-"
PRINT "chert werden (J/N)? ";

DO
   DO: a$ = UCASE$(INKEY$)
   LOOP UNTIL LEN(a$)
LOOP UNTIL a$ = "N" OR a$ = "J"
PRINT a$

IF a$ = "N" THEN ROLLBACK ALL             ' Wenn nderungen rckgngig ge-
                                          ' macht werden mssen: ROLLBACK ALL
                                          ' stellt den Status zum Zeitpunkt
                                          ' des BEGINTRANS-Befehls wieder her
COMMITTRANS: CLOSE                        ' COMMITTRANS wre eigentlich gar
                                          ' nicht notwendig, da CLOSE es au-
                                          ' tomatisch ausfhrt. Nach COMMIT-
                                          ' TRANS kann mit ROLLBACK nichts
                                          ' mehr zurckgenommen werden.

SYSTEM                                    ' Programmende

' Diese Prozedur zeigt den Datensatz, der in der globalen Variablen
' Zugriff gespeichert ist, entweder ausfhrlich (vierzeilig) oder kurz
' (einzeilig) an. Die Funktion RTRIM$ zum Entfernen der berflssigen
' Leerstellen wird nur da benutzt, wo in derselben Zeile noch weitere
' Zeichen ausgegeben werden.
'
SUB AnzeigeDatensatz (Modus AS INTEGER)
   
   IF Modus = Ausfuehrlich THEN
      PRINT
      PRINT SPC(5); RTRIM$(Zugriff.Vorname); " "; Zugriff.Name
      PRINT SPC(5); Zugriff.Strasse
      PRINT SPC(5); RTRIM$(Zugriff.PLZ); " "; Zugriff.Ort
      PRINT SPC(5); "Telefon "; Zugriff.Telefon
   ELSE
      PRINT RTRIM$(Zugriff.Vorname); " "; RTRIM$(Zugriff.Name); ", ";
      PRINT RTRIM$(Zugriff.Strasse); ", ";
      PRINT RTRIM$(Zugriff.PLZ); " "; RTRIM$(Zugriff.Ort); ", ";
      PRINT "Telefon "; RTRIM$(Zugriff.Telefon); "."
   END IF
         
END SUB

' Diese Prozedur ffnet die ISAM-Datenbank (gem den Konstanten im Modul-
' code). Auerdem werden die beiden bentigten Indexlisten erstellt.
'
SUB DatenbankOeffnen

   PRINT
   PRINT "------------------------"
   PRINT "---   ISAMDEMO.BAS   ---"
   PRINT "---  Adredatenbank  ---"
   PRINT "------------------------"
   PRINT

   ON LOCAL ERROR RESUME NEXT
   OPEN Datenfile FOR ISAM Datentyp Datenbank AS #1
   IF ERR = 0 THEN
      ' Wenn die Datenbank schon existiert, gibt das hier
      ' Fehler. Aber das ist ja egal.
      CREATEINDEX #1, "NameVorname", 1, "Name", "Vorname"
      CREATEINDEX #1, "PLZOrt", 0, "PLZ", "Ort"
   ELSE
      'Programm abbrechen.
      IF ERR = 73 THEN
         PRINT "ISAM ist nicht geladen."
      ELSE
         PRINT "Die Datei "; Datenfile; " kann nicht geffnet werden."
      END IF
      SYSTEM
   END IF

   ' Hier fngt die "Transaktion" an. BEGINTRANS wird bentigt, um den
   ' ROLLBACK-Befehl benutzen zu knnen. Alle Operationen, die mit dem
   ' Programm durchgefhrt werden, werden als eine einzige Transaktion
   ' verstanden.
   BEGINTRANS

END SUB

' Diese Prozedur erstellt mittels der Prozedur AnzeigeDatensatz eine Liste
' aller Adressen (alphabetisch sortiert) oder eine Liste eines beliebigen
' Postleitzahlgebietes (nach PLZ sortiert).
'
SUB Datenliste

   DIM VonPLZ AS STRING, BisPLZ AS STRING

   PRINT
   PRINT "Datenliste fr alle Datenstze oder fr bestimmtes PLZ-Gebiet (A/P)? ";
   DO
      DO: a$ = UCASE$(INKEY$): LOOP UNTIL LEN(a$)
   LOOP UNTIL a$ = "A" OR a$ = "P"
   PRINT a$
   PRINT

   SELECT CASE a$
   CASE "A"                               ' LISTE NACH NAMEN SORTIERT:
      SETINDEX 1, "NameVorname"           ' Indexliste mit Sortierung nach
                                          ' Namen anwhlen
      MOVEFIRST 1                         ' Zeiger auf ersten Datensatz nach
                                          ' neuer Sortierung setzen (eigent-
                                          ' lich hier berflssig, weil von
                                          ' SETINDEX automatisch ausgefhrt)
      DO UNTIL EOF(1)                     ' Solange, bis der Zeiger hinter
                                          ' letzten Datensatz zeigt:
         RETRIEVE 1, Zugriff              '    Datensatz, auf den der Zeiger
                                          '    zeigt, in Zugriff lesen,
         AnzeigeDatensatz Kurz            '    ...anzeigen...
         MOVENEXT 1                       '    und Zeiger weiterstellen.
      LOOP
   CASE "P"                               ' LISTE NACH PLZ sortiert:
      PRINT "Von PLZ (ganze PLZ oder";
      PRINT " Anfangsziffern; 0 =";
      PRINT " von Anfang): ";
      LINE INPUT VonPLZ
      PRINT "Bis PLZ (ganze PLZ oder";
      PRINT " Anfangsziffern; 0 = ";
      PRINT "bis Ende):    ";
      LINE INPUT BisPLZ
      SETINDEX 1, "PLZOrt"                ' Index fr PLZ-Sortierung setzen
      IF VonPLZ = "0" THEN                ' Wenn "Von Anfang" gewhlt, dann
         MOVEFIRST 1                      ' Zeiger auf erstes Element setzen,
      ELSE                                ' sonst auf das erste Element, das
         SEEKGE 1, VonPLZ                 ' >= der Anfangs-PLZ ist
      END IF
      DO UNTIL EOF(1)                     ' Solange, bis der Zeiger hinter den
                                          ' letzten Datensatz zeigt:
         RETRIEVE 1, Zugriff              ' Datensatz, auf den der Zeiger
                                          ' zeigt in Zugriff einlesen
         IF BisPLZ <> "0" THEN            ' wenn nicht "bis Ende" gewhlt wurde:
            IF TEXTCOMP(LEFT$(Zugriff.PLZ, LEN(BisPLZ)), BisPLZ) = 1 THEN EXIT DO
         END IF                           ' prfen, ob die PLZ des gelesenen
                                          ' Datensatzes schon auerhalb des
                                          ' Bereiches liegt; wenn ja, Schleife
                                          ' verlassen.
         AnzeigeDatensatz Kurz            ' Datensatz anzeigen
         MOVENEXT 1                       ' Zeiger weiterstellen
      LOOP
   END SELECT

END SUB

' Diese Prozedur lt den Benutzer - unkomfortabel zwar, aber ausreichend -
' einen Datensatz eingeben. In der Variablen Vorgabe steht, was eingesetzt
' wird, wenn der Benutzer einfach ENTER drckt. Die Eingaben werden in die
' Variable NeuerSatz geschrieben. Wenn NeuerSatz schon Daten enthlt, wer-
' den diese Elemente nicht mehr abgefragt (eine Tatsache, die in diesem
' Demo-Programm gar nicht genutzt wird).
'
SUB DatensatzEingabe (Vorgabe AS Datentyp, NeuerSatz AS Datentyp)

   PRINT
   DO UNTIL LEN(RTRIM$(NeuerSatz.Name))
      IF LEN(RTRIM$(Vorgabe.Name)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.Name
      END IF
      LINE INPUT "Name:          "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.Name
      NeuerSatz.Name = temp$
   LOOP

   DO UNTIL LEN(RTRIM$(NeuerSatz.Vorname))
      IF LEN(RTRIM$(Vorgabe.Vorname)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.Vorname
      END IF
      LINE INPUT "Vorname:       "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.Vorname
      NeuerSatz.Vorname = temp$
   LOOP

   DO UNTIL LEN(RTRIM$(NeuerSatz.Strasse))
      IF LEN(RTRIM$(Vorgabe.Strasse)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.Strasse
      END IF
      LINE INPUT "Strasse:       "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.Strasse
      NeuerSatz.Strasse = temp$
   LOOP

   DO UNTIL LEN(RTRIM$(NeuerSatz.PLZ))
      IF LEN(RTRIM$(Vorgabe.PLZ)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.PLZ
      END IF
      LINE INPUT "PLZ:           "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.PLZ
      NeuerSatz.PLZ = temp$
   LOOP

   DO UNTIL LEN(RTRIM$(NeuerSatz.Ort))
      IF LEN(RTRIM$(Vorgabe.Ort)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.Ort
      END IF
      LINE INPUT "Ort:           "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.Ort
      NeuerSatz.Ort = temp$
   LOOP

   DO UNTIL LEN(RTRIM$(NeuerSatz.Telefon))
      IF LEN(RTRIM$(Vorgabe.Telefon)) THEN
         PRINT "(Vorgabe)      "; Vorgabe.Telefon
      END IF
      LINE INPUT "Telefon:       "; temp$
      IF temp$ = "" THEN temp$ = Vorgabe.Telefon
      NeuerSatz.Telefon = temp$
   LOOP
    
END SUB

' Diese Prozedur zeigt das Hauptmen an und verarbeitet die Auswahlen des
' Benutzers, so lange, bis er "Programmende" whlt.
'
'
SUB HauptMenue

   DIM Vorgabe AS Datentyp

   DO
      PRINT
      PRINT "----------------------------------"
      PRINT "Datenbank enthlt"; LOF(1); "Stze"
      PRINT "1. Daten anfgen"
      PRINT "2. Daten lschen"
      PRINT "3. Daten ndern"
      PRINT "4. Einzelnen Datensatz anzeigen"
      PRINT "5. Datenliste anzeigen"
      PRINT "6. Undo"
      PRINT "9. Programmende"
      LOCATE , , 1                        ' Cursor einschalten
      PRINT "Ihre Wahl> ";
      DO
         a$ = INPUT$(1)
      LOOP UNTIL LEN(a$)
      PRINT a$
      PRINT "----------------------------------"
      SELECT CASE VAL(a$)
      CASE 1
         PRINT
         Zugriff = Leer
         DatensatzEingabe Leer, Zugriff   ' Neuen Datensatz eingeben
         x% = SAVEPOINT                   ' SAVEPOINT-Markierung setzen
         INSERT 1, Zugriff                ' Neuen Datensatz in
                                          ' Datenbank aufnehmen
      CASE 2
         SucheDatensatz "Welchen Datensatz lschen?"
         IF NOT EOF(1) THEN               ' Wenn der Zeiger nicht hinter dem
                                          ' letzten Datensatz steht,
            x% = SAVEPOINT                ' SAVEPOINT-Markierung setzen
            DELETE #1                     ' Datensatz, auf den der Zeiger
                                          ' zeigt, lschen
            PRINT "* 1 Datensatz gelscht"
         ELSE
            PRINT "* Kein Datensatz gelscht"
         END IF
      CASE 3
         SucheDatensatz "Welchen Datensatz mchten Sie ndern?"
         IF NOT EOF(1) THEN               ' Wenn der Zeiger nicht hinter den
                                          ' letzten Datensatz zeigt,
            Vorgabe = Zugriff             ' Zu ndernde Variable als Vorgabe
            Zugriff = Leer                ' fr Neueingabe:
            DatensatzEingabe Vorgabe, Zugriff
            x% = SAVEPOINT                ' SAVEPOINT-Markierung setzen
            UPDATE 1, Zugriff             ' Datensatz, auf den der Zeiger
                                          ' zeigt, durch Zugriff ersetzen
         END IF
      CASE 4
         SucheDatensatz "Welcher Datensatz soll angezeigt werden?"
         ' SucheDatensatz liest den Datensatz selbst in Zugriff ein, also
         ' mu nur nocht di eAnzeige aufgerufen werden:
         IF NOT EOF(1) THEN AnzeigeDatensatz Ausfuehrlich
      CASE 5
         Datenliste                       ' Die Prozedur kmmert sich um
                                          ' alles weitere
      CASE 6
         ROLLBACK                         ' Den Zustand der Datenbank zum
                                          ' Zeitpunkt der letzten SAVEPOINT-
                                          ' Markierung wiederherstellen
      CASE 9
         EXIT DO                          ' Men verlassen
      CASE ELSE
      END SELECT
   LOOP

END SUB

' Diese Prozedur wird von allen anderen dazu benutzt, einen bestimmten
' Datensatz ausfindig zu machen. Wenn der Benutzer mit Hilfe dieser Prozedur
' einen Datensatz als den richtigen identifiziert, ist dieser Datensatz
' beim Verlassen der Prozedur in der Variablen Zugriff gespeichert, und
' auerdem zeigt der Dateizeiger auf diesen Datensatz in der ISAM-Datei.
' Verluft diese Prozedur jedoch erfolglos (Abbruch oder kein Datensatz
' gefunden), dann zeigt der Datenzeiger hinter den letzten Datensatz, EOF(1)
' hat dann den Funktionswert -1, und daran erkennen alle anderen Prozeduren,
' da SucheDatensatz nicht erfolgreich war.
'
SUB SucheDatensatz (Titel AS STRING)

   DIM NachName AS STRING, Postleitzahl AS STRING

   PRINT
   PRINT Titel
   PRINT "1. Suchen nach Namen"
   PRINT "2. Suchen nach Postleitzahl"
   PRINT "Ihre Wahl> ";
   DO
      DO: a$ = INKEY$: LOOP UNTIL LEN(a$)
   LOOP UNTIL a$ = "1" OR a$ = "2"
   PRINT a$
   PRINT "- (j/n/a) bedeutet (ja/nein/abbruch) -"
   SELECT CASE VAL(a$)
   CASE 1                                 ' SUCHEN NACH NAMEN
      SETINDEX 1, "NameVorname"           ' Namensindex aktivieren
      PRINT "Nachname (oder Anfangsbuch";
      PRINT "staben dessen): ";
      LINE INPUT NachName
      SEEKGE 1, NachName                  ' Zeiger auf ersten Datensatz
                                          ' setzen, dessen Nachname >= dem
                                          ' eingegebenen Namen ist
      DO UNTIL EOF(1)                     ' Solange bis der Datenzeiger hin-
                                          ' ter dem letzten Dastensatz steht:
         RETRIEVE 1, Zugriff              ' Datensatz, auf den der Datenzei-
                                          ' ger zeigt, in Zugriff einlesen
         IF TEXTCOMP(LEFT$(Zugriff.Name, LEN(NachName)), NachName) THEN
                                          ' Wenn der eingelesene Name schon
                                          ' zu weit hinten im Alphabet steht
                                          ' (wenn die ersten Buchstaben nicht
                                          ' mehr mit den eingegebenen ber-
                                          ' einstimmen), wird abgebrochen.
            EXIT DO
         END IF
         PRINT RTRIM$(Zugriff.Vorname); " "; RTRIM$(Zugriff.Name);
         PRINT TAB(60); "OK (j/n/a)? ";   ' Namen ausgeben und fragen, ob er
                                          ' der gewnschte ist.
         DO
            DO: a$ = UCASE$(INKEY$): LOOP UNTIL LEN(a$)
         LOOP UNTIL INSTR("JNA", a$)
         PRINT a$
         IF a$ = "J" OR a$ = "A" THEN
            EXIT DO                       ' Bei JA und ABBRUCH: Suche beenden.
         END IF
         MOVENEXT 1                       ' Sonst Zeiger weiterstellen und
                                          ' weitersuchen.
      LOOP
      IF a$ = "J" THEN
         EXIT SUB                         ' Bei JA: Prozedur verlassen
      ELSE
         MOVELAST 1: MOVENEXT 1           ' Bei ABBRUCH oder wenn keine DS
                                          ' mehr gefunden wurden, Zeiger hin-
                                          ' ter letzten DS stellen.
         IF NOT a$ = "A" THEN
            PRINT "* Keine weiteren Datenstze gefunden."
         END IF
      END IF
   CASE 2
      SETINDEX 1, "PLZOrt"                ' SUCHEN NACH PLZ
      PRINT "Postleitzahl (oder erste ";  ' (gleiches Prinzip wie oben)
      PRINT "Ziffern davon): "
      LINE INPUT Postleitzahl
      SEEKGE 1, Postleitzahl
      DO UNTIL EOF(1)
         RETRIEVE 1, Zugriff
         IF TEXTCOMP(LEFT$(Zugriff.PLZ, LEN(Postleitzahl)), Postleitzahl) THEN
            EXIT DO
         END IF
         PRINT RTRIM$(Zugriff.Vorname); " "; RTRIM$(Zugriff.Name); ","
         PRINT "   "; RTRIM$(Zugriff.PLZ); " "; RTRIM$(Zugriff.Ort);
         PRINT TAB(60); "OK (j/n/a)? ";
         DO
            DO: a$ = UCASE$(INKEY$): LOOP UNTIL LEN(a$)
         LOOP UNTIL INSTR("JNA", a$)
         PRINT a$
         IF a$ = "J" OR a$ = "A" THEN EXIT DO
         MOVENEXT 1
      LOOP
      IF a$ = "J" THEN
         EXIT SUB
      ELSE
         MOVELAST 1: MOVENEXT 1
         IF NOT a$ = "A" THEN
            PRINT "* Keine weiteren Datenstze gefunden."
         END IF
      END IF
   END SELECT

END SUB

