DECLARE FUNCTION MatDivS% (Matrix1() AS SINGLE, Matrix2() AS SINGLE, Matrix3() AS SINGLE)
REM $INCLUDE: 'matb.bi'

' Es knnen nur quadratische Matrizen invertiert werden.
' Bei der Multiplikation einer km-Matrix mit einer mn-Matrix
' entsteht eine kn-Matrix.
' Aus diesen beiden Voraussetzungen folgt, da
' - 1. Matrix2 quadratisch sein mu (nn)
' - 2. Matrix1 und Matrix3 die Dimension kn haben mssen.
' (In Matrix3 wird das Ergebnis der Division von Matrix1 durch
' Matrix2 geschrieben.)
FUNCTION MatDivS% (Matrix1() AS SINGLE, Matrix2() AS SINGLE, Matrix3() AS SINGLE)

   DIM FehlerCode AS INTEGER

   FehlerCode = MatInvS(Matrix2())
   IF FehlerCode = 0 THEN
      FehlerCode = MatMultS(Matrix1(), Matrix2(), Matrix3())
   END IF
   MatDivS% = FehlerCode

END FUNCTION

FUNCTION MatDivD% (Matrix1() AS DOUBLE, Matrix2() AS DOUBLE, Matrix3() AS DOUBLE)

   DIM FehlerCode AS INTEGER

   FehlerCode = MatInvD(Matrix2())
   IF FehlerCode = 0 THEN
      FehlerCode = MatMultD(Matrix1(), Matrix2(), Matrix3())
   END IF
   MatDivD% = FehlerCode

END FUNCTION
